=== modified file 'lib/lp/bugs/browser/tests/test_bugs.py'
--- lib/lp/bugs/browser/tests/test_bugs.py	2011-03-02 21:44:33 +0000
+++ lib/lp/bugs/browser/tests/test_bugs.py	2011-05-26 22:12:51 +0000
@@ -8,6 +8,7 @@
 from zope.component import getUtility
 
 from canonical.launchpad.webapp.publisher import canonical_url
+from canonical.launchpad.testing.pages import find_tag_by_id
 from canonical.testing.layers import DatabaseFunctionalLayer
 from lp.bugs.interfaces.malone import IMaloneApplication
 from lp.bugs.publisher import BugsLayer
@@ -67,3 +68,26 @@
         self.assertEqual(
             "Bug ['fnord', 'pting'] is not registered.", view.error_message)
         self.assertEqual(None, view.request.response.getHeader('Location'))
+
+    def test_search_specifications_form_rendering(self):
+        # The view's template directly renders the form widgets.
+        view = create_initialized_view(self.application, '+index')
+        content = find_tag_by_id(view.render(), 'search-all-bugs')
+        self.assertEqual('form', content.name)
+        self.assertTrue(
+            content.find(True, id='field.searchtext') is not None)
+        self.assertTrue(
+            content.find(True, id='field.actions.search') is not None)
+        self.assertTrue(
+            content.find(True, id='field.scope.option.all') is not None)
+        self.assertTrue(
+            content.find(True, id='field.scope.option.project') is not None)
+        target_widget = view.widgets['scope'].target_widget
+        self.assertTrue(
+            content.find(True, id=target_widget.show_widget_id) is not None)
+        text = str(content)
+        picker_script = (
+            "Y.lp.app.picker.create('DistributionOrProductOrProjectGroup'")
+        self.assertTrue(picker_script in text)
+        focus_script = "setFocusByName('field.searchtext')"
+        self.assertTrue(focus_script in text)

=== modified file 'lib/lp/bugs/templates/malone-index.pt'
--- lib/lp/bugs/templates/malone-index.pt	2011-05-26 17:55:24 +0000
+++ lib/lp/bugs/templates/malone-index.pt	2011-05-26 22:12:51 +0000
@@ -16,7 +16,7 @@
          tal:content="view/error_message">
         Error message.
       </p>
-      <form class="central" action="/bugs/+bugs" method="get">
+      <form id="search-all-bugs" class="central" action="/bugs/+bugs" method="get">
         <table>
           <tbody>
             <tr>
@@ -24,7 +24,8 @@
                 <input tal:replace="structure view/widgets/searchtext" />
               </td>
               <td>
-                <input type="submit" name="search" value="Search Bug Reports" />
+                <input id="field.actions.search" type="submit"
+                  name="search" value="Search Bug Reports" />
               </td>
             </tr>
             <tr>

